%define menus	%{!?_without_menus:1}%{?_without_menus:0}
%define section	free

Name:		findbugs
Version:	0.9.1
Release:	1jpp
Epoch:		0
Summary:	A Bug Pattern Detector for Java
License:	LGPL
URL:		http://findbugs.sourceforge.net/
Group:		Development/Debuggers
Vendor:		JPackage Project
Distribution:	JPackage
Source0:	http://download.sourceforge.net/findbugs/findbugs-0.9.1-source.zip
Source1:	%{name}-script
Source2:	%{name}-16x16.png
Source3:	%{name}-32x32.png
Source4:	%{name}-48x48.png
Source5:	%{name}.desktop
Source6:	%{name}-antlib-0.8.6.xml
Patch0:		findbugs-BugCollection.patch
Requires:	dom4j
Requires:	jaxen
Requires:	jpackage-utils >= 0:1.5
BuildRequires:	ant >= 0:1.6
BuildRequires:	dom4j
BuildRequires:	java-devel >= 0:1.4
BuildRequires:	jaxen
BuildRequires:	jpackage-utils >= 0:1.5
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
FindBugs is a program to find bugs in Java programs. It looks for 
instances of ``bug patterns''---code instances that are likely to be 
errors.

%if %{menus}
%package	mdkmenu
Summary:	Mandriva menu entry for %{name}
Group:		Development/Debuggers	
Requires:	%{name} = %{epoch}:%{version}

%description	mdkmenu
%{summary}.

%package	legacymenu
Summary:	Legacy menu entry for %{name}
Group:		Development/Debuggers
Requires:	%{name} = %{epoch}:%{version}
Conflicts:	redhat-menus

%description	legacymenu
%{summary}.
%endif

%if 0
%package	javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation

%description	javadoc
Javadoc for %{name}.
%endif

%prep
%setup -q
%__perl -p -i -e 's|<taskdef resource="clovertasks"/>\n||' build.xml
%__cp -a %{SOURCE6} src/antTask/edu/umd/cs/findbugs/anttask/antlib.xml

%patch0 -b .sav

%build
find . -name "*.jar" -a ! -name "bcel.jar" -exec rm -f {} \;
export CLASSPATH=$(build-classpath dom4j jaxen)
%__rm -f src/java/edu/umd/cs/findbugs/gui/OSXAdapter.java
# FIXME: setup is monolithic right now, as especially the ant task
# doesn't read the CLASSPATH
#%__perl -p -i -e 's|^Class-Path:.*\n||g' etc/*.MF
%__perl -p -i -e 's|dom4j-full.jar|dom4j.jar jaxen.jar|g' etc/*.MF
%__perl -p -i -e 's|plastic.jar||g' etc/*.MF
%__cp -p %{_javadir}/{dom4j,jaxen}.jar lib
export JAVA_HOME=/usr/lib/jvm/java-1.5.0
export OPT_JAR_LIST="ant/ant-nodeps ant/ant-junit junit"
ant -Dbuild.sysclasspath=last build
%if 0
ant -Dbuild.sysclasspath=last javadoc
%endif

%install
%__rm -rf %{buildroot}

# jars
%__mkdir_p %{buildroot}%{_javadir}/%{name}/lib
%__cp -a lib/bcel.jar %{buildroot}%{_javadir}/%{name}/lib
%__cp -a lib/findbugs{,GUI,-ant}.jar %{buildroot}%{_javadir}/%{name}/lib
(cd %{buildroot}%{_javadir}/%{name}/lib && %__ln_s %{_javadir}/dom4j.jar dom4j.jar && \
 %__ln_s %{_javadir}/jaxen.jar jaxen.jar)
(cd %{buildroot}%{_javadir}/%{name}/lib && for jar in *-%{version}*; do \
%__ln_s ${jar} ${jar/-%{version}/}; done)
%__cp -a plugin %{buildroot}%{_javadir}/%{name}

%__mkdir_p %{buildroot}%{_sysconfdir}/ant.d
%__cat > %{buildroot}%{_sysconfdir}/ant.d/%{name} << EOF
findbugs/lib/findbugs findbugs/lib/findbugs-ant
EOF

# script
%__mkdir_p %{buildroot}%{_bindir}
%__cp -a %{SOURCE1} %{buildroot}%{_bindir}/%{name}

# javadoc
%if 0
%__mkdir_p %{buildroot}%{_javadocdir}/%{name}-%{version}
%__cp -a doc/api/* %{buildroot}%{_javadocdir}/%{name}-%{version}
(cd %{buildroot}%{_javadocdir} && %__ln_s %{name}-%{version} %{name})
%__rm -rf doc/api
%endif

%if %{menus}
# mdk menu entry
%__mkdir_p %{buildroot}%{_menudir}
%__cat >%{buildroot}%{_menudir}/%{name} <<EOF
?package(%{name}):\\
command="%{_bindir}/%{name}"\\
needs="X11"\\
icon="%{name}.png"\\
section="Applications/Development/Tools"\\
title="%{name}"\\
longtitle="Bug Pattern Detector for Java"
EOF

# mdk icons
%__install -D -p -m 644 %{SOURCE2} %{buildroot}%{_miconsdir}/%{name}.png 
%__install -D -p -m 644 %{SOURCE3} %{buildroot}%{_iconsdir}/%{name}.png 
%__install -D -p -m 644 %{SOURCE4} %{buildroot}%{_liconsdir}/%{name}.png

# freedesktop.org menu entry
%__install -D -p -m 644 %{SOURCE5} \
  %{buildroot}%{_datadir}/applications/jpackage-%{name}.desktop

# icons for freedesktop.org and legacy menu entries
%__install -D -p -m 644 %{SOURCE2} \
  %{buildroot}%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
install -D -p -m 644 %{SOURCE3} \
  %{buildroot}%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
%__install -D -p -m 644 %{SOURCE4} \
  %{buildroot}%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
%__install -D -p -m 644 %{SOURCE4} \
  %{buildroot}%{_datadir}/pixmaps/%{name}.png

# legacy menu entry
%__install -D -p -m 644 %{SOURCE4} \
  %{buildroot}%{_sysconfdir}/X11/applnk/Development/%{name}.desktop
%endif

%clean
%__rm -rf %{buildroot}

%if %{menus}
%post mdkmenu
%{update_menus}

%postun mdkmenu
%{clean_menus}
%endif

%if 0
%post javadoc
%__rm -f %{_javadocdir}/%{name}
%__ln_s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ $1 -eq 0 ]; then
  %__rm -f %{_javadocdir}/%{name}
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc LICENSE.txt README.txt bin/* design/* doc/*
%attr(0755,root,root) %{_bindir}/*
%{_javadir}/%{name}
%config(noreplace) %{_sysconfdir}/ant.d/%{name}

%if %{menus}
%{_datadir}/applications/*-%{name}.desktop
%{_datadir}/icons/*/*/apps/*
%{_datadir}/pixmaps/%{name}.png

%files mdkmenu
%defattr(0644,root,root,0755)
%{_menudir}/%{name}
%{_iconsdir}/%{name}.png
%{_miconsdir}/%{name}.png
%{_liconsdir}/%{name}.png

%files legacymenu
%defattr(0644,root,root,0755)
%{_sysconfdir}/X11/applnk/Development/*
%endif

%if 0
%files javadoc
%defattr(0644,root,root,0755)
%dir %{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}-%{version}/*
%ghost %dir %{_javadocdir}/%{name}
%endif

%changelog
* Wed Aug 17 2005 Ralph Apel <r.apel@r-apel.de> 0:0.9.1-1jpp
- Patch BugCollection.java not to use org.dom4j.io.aelfred.SAXDriver
- Upgrade to 0.9.1
- Provide for xmlvalidate and junit tasks

* Sat Apr 16 2005  David Walluck <david@jpackage.org> 0:0.8.7-1jpp
- 0.8.7
- javadoc package removed as javadocs are no longer built upstream

* Tue Feb 22 2005  David Walluck <david@jpackage.org> 0:0.8.6-4jpp
- fix build when missing clover
- fix build with jdk < 1.5
- added antlib.xml to findbugs-ant.jar (Joseph Wortmann <jwortmann@awarix.com>)

* Tue Feb 08 2005 David Walluck <david@jpackage.org> 0:0.8.6-3jpp
- fix mdk menu location

* Sun Feb 06 2005 David Walluck <david@jpackage.org> 0:0.8.6-2jpp
- minor macro changes

* Sun Jan 30 2005 David Walluck <david@jpackage> 0:0.8.6-1jpp
- release
